let
  pkgs = import <nixpkgs> { };
  nmigen-latest = pkgs.python3Packages.nmigen.overrideAttrs(oa: {
    src = pkgs.fetchFromGitHub {
      owner = "m-labs";
      repo = "nmigen";
      rev = "39602ae3fdd143f3aa130278fb185cf3ff98d6da";
      sha256 = "1b0rjbb6is6nzbcnxrwh5iv4k9xcac0ijq5kp47wdg9rhbnaa5w0";
    };
  });
  minerva-latest = pkgs.python3Packages.buildPythonPackage {
    name = "minerva";
    
    src = pkgs.fetchFromGitHub {
      owner = "lambdaconcept";
      repo = "minerva";
      rev = "714d83530c81a681fe414b835564ab09acb10cb7";
      sha256 = "0s4mq05n8k25amisak4yr6nwndm4czmvzp06fjk1bmg6xzb2jf1a";
    };
    
    nativeBuildInputs = [ nmigen-latest pkgs.yosys pkgs.symbiyosys ];
  };
in
 pkgs.mkShell {
    buildInputs = [
      (pkgs.python3.withPackages(ps: [nmigen-latest]))
      pkgs.yosys pkgs.symbiyosys minerva-latest
    ];
  }
